Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# ACE_Null_Semaphore Class Reference

Implement a do nothing ACE_Semaphore, i.e., all the methods are no ops. More...

`#include <Null_Semaphore.h>`

List of all members.

## Public Member Functions
| ACE_Null_Semaphore (unsigned int=1, int=0, const ACE_TCHAR *=0, void *=0, int=0x7fffffff)
| ~ACE_Null_Semaphore (void)
int | remove (void)
| Return 0.
int | acquire (void)
| Return 0.
int | acquire (ACE_Time_Value &)
| Return -1 with <errno> == <etime>.
int | acquire (ACE_Time_Value *)
| Return -1 with <errno> == <etime>.
int | tryacquire (void)
| Return 0.
int | release (void)
| Return 0.
int | release (size_t)
| Return 0.
int | acquire_write (void)
| Return 0.
int | tryacquire_write (void)
| Return 0.
int | tryacquire_write_upgrade (void)
| Return 0.
int | acquire_read (void)
| Return 0.
int | tryacquire_read (void)
| Return 0.
void | dump (void) const
| Dump the state of an object.

## Detailed Description

Implement a do nothing ACE_Semaphore, i.e., all the methods are no ops.

Although the methods are no-ops, the return values are different for the blocking as opposed to timed acquires. The blocking version of acquire() is often used to serialize access to a critical section, whereas the timed version is often used to wait for another thread to update some condition or change some shared state. When using an ACE_Null_Semaphore, however, there's no other thread involved to change a state or condition (otherwise, a null semaphore would be inappropriate). Returning an error value signifies that the state or condition has not been (and can't be) changed, which is consistent with the behavior of the threaded case where a timeout occurs before the state or condition is changed.

## Constructor & Destructor Documentation

ACE_Null_Semaphore::ACE_Null_Semaphore | ( | unsigned | int = `1`,
|  | int | = `0`,
|  | const ACE_TCHAR * | = `0`,
|  | void * | = `0`,
|  | int | = `0x7fffffff`
| ) | `[inline]`

ACE_Null_Semaphore::~ACE_Null_Semaphore | ( | void |  | ) | `[inline]`

## Member Function Documentation

int ACE_Null_Semaphore::acquire | ( | ACE_Time_Value * |  | ) | `[inline]`

| Return -1 with <errno> == <etime>.

int ACE_Null_Semaphore::acquire | ( | ACE_Time_Value & |  | ) | `[inline]`

| Return -1 with <errno> == <etime>.

int ACE_Null_Semaphore::acquire | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::acquire_read | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::acquire_write | ( | void |  | ) | `[inline]`

| Return 0.

void ACE_Null_Semaphore::dump | ( | void |  | ) | const`[inline]`

| Dump the state of an object.

int ACE_Null_Semaphore::release | ( | size_t |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::release | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::remove | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::tryacquire | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::tryacquire_read | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::tryacquire_write | ( | void |  | ) | `[inline]`

| Return 0.

int ACE_Null_Semaphore::tryacquire_write_upgrade | ( | void |  | ) | `[inline]`

| Return 0.

The documentation for this class was generated from the following file:

- Null_Semaphore.h